// *****************************************************************************
// *	axpad02s.c
// *
// *	AXP-AD02
// *
// *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
// *
// *	Date Sep.2000
// *
// *	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
// *
// *
// *  FAd02wSingleSampling gpǉ
// *
// ****************************************************************************
unit Axpad02s;

interface

uses
  Windows, Messages, SysUtils, Forms,
	Axpad02w;

const
	szTitle = 'Sample';
	szAd02	= 'AXP-AD02';

type
  TMainForm = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
		procedure ResultMessage(strbuf:String);
		procedure ErrorMessage(wLogSocket:Word);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}
//===========================================================
// <EVENT>FormCreate
//===========================================================
procedure TMainForm.FormCreate(Sender: TObject);
var
	strbuf:			String;
	wLogSocket:	Word;
	hWnd:				THandle;
	InitArg:		DWord;
	dwDllVer:		DWord;
	dwDrvVer:		DWord;
	ri:					TAD02_RESOURCE;
	md:					TAD02_MODE;
  dwNumData:	DWord;
	dwStatus:		DWord;
	Buffer:			TADBUFF;
	i:					DWord;
	bValue:			Byte;

	dwCh:				DWORD;
	dwVRange:		DWORD;
	wSingleData:WORD;

begin
	//---------------------------------------------------------
	// Axpad02.dll ̎gp錾
	//---------------------------------------------------------
	if Ad02wDllOpen() = FALSE then begin
		ErrorMessage( AD02_SOCKET_AUTO );
		Halt;
	end;
	//---------------------------------------------------------
	// o[W\
	//---------------------------------------------------------
	if Ad02wGetVersion(dwDllVer,dwDrvVer) = FALSE then begin
		ErrorMessage( AD02_SOCKET_AUTO );
		Halt;
	end;
	strbuf:= Format(
						'GetVersion'#10+
						'Dll Version:%08xH'#10+
						'Drv Version:%08xH', [dwDllVer,dwDrvVer]);
	ResultMessage(strbuf);
	//---------------------------------------------------------
	// foCX̎gp錾
	//---------------------------------------------------------
	wLogSocket:=AD02_SOCKET_AUTO; // 󂫃foCXw
	hWnd:=0; InitArg:=0;
	if Ad02wCreate(wLogSocket,hWnd,0,InitArg) = FALSE then begin
		ErrorMessage( AD02_SOCKET_AUTO );
		Halt;
	end;
	strbuf:=Format(
						'AXP-AD02 Created'#10+
						'LogSocket:%2d',[wLogSocket]);
	ResultMessage(strbuf);
	//---------------------------------------------------------
	// \[X\
	//---------------------------------------------------------
	if Ad02wGetResource(wLogSocket,@ri) = FALSE then begin
		ErrorMessage( wLogSocket );
		Halt;
	end;
	strbuf:=Format(
						'AXP-AD02 Resource'#10+
						'PortBase:%04xH - %04xH'#10+
						'Irq:%d',
						[ri.dwIOPortBase[1],ri.dwIOPortBase[1]+ri.dwIOPortLength[1]-1,
            ri.dwIRQRegisters[1]]);
	ResultMessage(strbuf);
	//---------------------------------------------------------
	// TvO[h̐ݒ
	//---------------------------------------------------------
	md.cwBuffer				:= 256;								// obt@TCYi[hPʁj
	md.dwChFirst			:= 0;									// TvOJn`li0 ` 7j
	md.dwChLast				:= 0;									// TvOŏI`li0 ` 7j
	md.dwSampleMode		:= AD02_SM_ONESHOT;		// TvO[h
	md.dwTimer				:= 50;								// ^C}li1`255j
	md.dwTrigSource		:= AD02_TS_INTERNAL;	// gK\[X
	md.dwVoltageRange	:= AD02_VR_S10V;			// ͓dW

	if Ad02wSetMode(wLogSocket,@md) = FALSE then begin
		ErrorMessage( wLogSocket );
		Halt;
	end;
	strbuf:=Format(
					'AXP-AD02 Sampling mode'#10+
					'TvOJn`l = %d'#10+
					'TvOŏI`l = %d'#10+
					'obt@TCY = %d'#10+
					'^C}l = %d'#10+
					'샂[h = %d'#10+
					'gK\[X = %d'#10+
					'dW = %d',
					[	md.dwChFirst,
						md.dwChLast,
						md.cwBuffer,
						md.dwTimer,
						md.dwSampleMode,
						md.dwTrigSource,
						md.dwVoltageRange]);
	ResultMessage(strbuf);
	//---------------------------------------------------------
	// TvOJn
	//---------------------------------------------------------
	if Ad02wStartSampling(wLogSocket) = FALSE then begin
		ErrorMessage( wLogSocket );
		Halt;
	end;
	ResultMessage('AXP-AD02 Sampling started');
	//---------------------------------------------------------
	// TvOXe[^X擾
	//---------------------------------------------------------
	if Ad02wGetSamplingStatus(wLogSocket,dwNumData,dwStatus) = FALSE then begin
		ErrorMessage( wLogSocket );
		Halt;
	end;
	strbuf:=Format(
						'AXP-AD02 Sampling status'#10+
						'f[^ = %d'#10+
						'Xe[^X = %xH',[dwNumData,dwStatus]);
	ResultMessage(strbuf);
	//---------------------------------------------------------
	// TvOς݃f[^擾
	//---------------------------------------------------------
	if dwNumData > AD02_BUFFER_SIZE then dwNumData := AD02_BUFFER_SIZE;
  if dwNumData > 0 then begin
		if Ad02wGetData(wLogSocket,@Buffer,dwNumData) = FALSE then begin
			ErrorMessage( wLogSocket );
			Halt;
		end;
		// f[^XXҏW甲悤ɂ
		if dwNumData > 99 then dwNumData := 99;
		strbuf:='TvOς݃f[^擾'#10;
		for i:=1 to dwNumData -1 do begin
			strbuf:=strbuf+Format('%2d:%.xH  ',[i,Buffer[i]]);
			if i mod 4 = 0 then strbuf:=strbuf+#10;
		end;
		ResultMessage(strbuf);
	end;
	//---------------------------------------------------------
	// TvO~
	//---------------------------------------------------------
	if Ad02wStopSampling(wLogSocket) = FALSE then begin
		ErrorMessage( wLogSocket );
		Halt;
	end;
	ResultMessage('AXP-AD02 Sampling stop');
	//---------------------------------------------------------
	// VOTvOs
	//---------------------------------------------------------
	dwCh			:= 0;
	dwVRange	:= AD02_VR_S10V;

	if Ad02wSingleSampling(wLogSocket,dwCh,dwVRange,wSingleData) = FALSE then begin
		ErrorMessage( wLogSocket );
		Halt;
	end;
	strbuf:=Format(
						'VOTvO'#10+
						'`l %d : %s',
						[dwCh,IntToHex(wSingleData,4)]);
	ResultMessage(strbuf);
	//---------------------------------------------------------
	// ėp͂̒l擾
	//---------------------------------------------------------
	if Ad02wInPort(wLogSocket,bValue) = False then begin
		ErrorMessage( wLogSocket );
		Halt;
	end;
	strbuf:='ėp͂̒l '+IntToHex(bValue,2);
	ResultMessage(strbuf);
	//---------------------------------------------------------
	// ėpo͂ɒlo
	//---------------------------------------------------------
	bValue:=$A;
	if Ad02wOutPort(wLogSocket,bValue) = False then begin
		ErrorMessage( wLogSocket );
		Halt;
	end;
	strbuf:='ėpo͂ $Ao͂܂';
	ResultMessage(strbuf);
	//---------------------------------------------------------
	// foCXJ
	//---------------------------------------------------------
	if Ad02wClose(wLogSocket) = FALSE then begin
		ErrorMessage( wLogSocket );
		Halt;
	end;
	strbuf:=Format(
						'AXP-AD02 Close'#10+
						'LogSocket:%2d',[wLogSocket]);
	ResultMessage(strbuf);
	Halt;
end;
// <EVENT>FormClose
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	//---------------------------------------------------------
	// Axpad02.dll J
	//---------------------------------------------------------
	if Ad02wDllClose() = FALSE then begin
		ErrorMessage( AD02_SOCKET_AUTO );
	end;
end;
//===========================================================
// ʂ\
//===========================================================
procedure TMainForm.ResultMessage(strbuf:String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//===========================================================
// G[bZ[W\
//===========================================================
procedure TMainForm.ErrorMessage(wLogSocket:Word);
var
	dwRes:	DWord;
	strbuf:	String;
begin
	dwRes:=Ad02wGetLastError(wLogSocket);
	if dwRes = AD02_ERR_WRAPDLL then begin
		strbuf:='DLL Load error';
	end else begin
		strbuf:=Format(
							'AXP-AD02 error'#10#10'Error code:%08xH',[dwRes]);
	end;
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
