//*******************************************************************
//	Axpad02w.pas
//
//	AXP-AD02
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//*******************************************************************

unit Axpad02w;

interface

uses
	Windows;

const
	// obt@TCYiύX\j
	AD02_BUFFER_SIZE					= 65535;
	// DLL 
	AD02_DLL_NAME							= 'Axpad02.dll';
	//-----------------------------------------------------------------
	// G[R[h
	//-----------------------------------------------------------------
	AD02_SUCCESS							= 0;	// ُȂiIj
	AD02_ERR_SYSTEM						= 1;	// ɃhCo[hĂȂ\܂
	AD02_ERR_NO_DEVICE				=	2;	// gp\ȃfoCX܂
	AD02_ERR_NOT_CREATED			=	3;	// w̃foCX͎gp錾Ă܂
	AD02_ERR_IN_USE						= 4;	// w̃foCX͑̃vZXŎgpł
	AD02_ERR_INVALID_SOCKET		= 5;	// Ș_\Pbgԍł
	AD02_ERR_RESOURCE					= 6;	// \[XG[
	AD02_ERR_INVALID_ARGUMENT	= 7;	// sȈw肵܂
	AD02_ERR_VOLTAGE_RANGE		= 8;	// sȓdlw肵܂
	AD02_ERR_CHANNEL					= 9;	// sȃ`lw肵܂
	AD02_ERR_TIMER						= 10;	// sȃ^C}w肵܂
	AD02_ERR_TRIG_SOURCE			= 11;	// sȃgKw肵܂
	AD02_ERR_SAMPLE_MODE			= 12;	// sȃ[hw肵܂
	AD02_ERR_NOT_ENOUGH_MEM		= 13;	// w肳ꂽobt@mۂł܂ł
	AD02_ERR_NO_DATA					= 14;	// f[^v܂
	AD02_ERR_NO_SETMODE				= 20; // [hݒ肳Ă܂ł
	AD02_ERR_BUSY							= 21; // TvO쒆ł
	//-----------------------------------------------------------------
	// ̑̒萔
	//-----------------------------------------------------------------
	AD02_SOCKET_AUTO					=	$FFFF;
	AD02_MAX_SOCKETS					= 4;	// foCX͂S܂Ŏg܂
	AD02_NUM_CHANNELS					= 8;
	AD02_ERR_WRAPDLL 					= DWord(-1); 		// bp[֐G[
	//-----------------------------------------------------------------
	// dW
	//-----------------------------------------------------------------
	AD02_VR_S10V							= 0;	// +-10V range
	AD02_VR_S5V								= 1;	// +- 5V range
	//-----------------------------------------------------------------
	// gK
	//-----------------------------------------------------------------
	AD02_TS_INTERNAL					= 0;	// gKgp
	AD02_TS_EXTERNAL					= 1;	// OgKgp
	//-----------------------------------------------------------------
	// TvO
	//-----------------------------------------------------------------
	AD02_SM_ONESHOT						= 0;	// Vbg
	AD02_SM_CONTINUOUS				= 1;	// ATvO
	//-----------------------------------------------------------------
	// TvOXe[^X̃rbg}XN
	//-----------------------------------------------------------------
	AD02_BMSST_BUSY						= (1 shl  0);	// Busy
	AD02_BMSST_EOC						= (1 shl  1);	// Not busy
	AD02_BMSST_HALF_FULL			= (1 shl  2);	// Ring buffer half full
	AD02_BMSST_OVERFLOW				= (1 shl  3);	// Ring buffer overflow
	AD02_BMSST_OVERRUN				= (1 shl  4);	// FIFO overrun
	//-----------------------------------------------------------------
	// hCo瑗Ă郁bZ[W
	// ̒l uWMBase𑫂lĂ܂
	//-----------------------------------------------------------------
	AD02_WM_OFS_CARD_REMOVAL	= 0;
	AD02_WM_OFS_EOC						= 1;
	AD02_WM_OFS_HALF_FULL			= 2;
	AD02_WM_OFS_OVERFLOW			= 3;
	AD02_WM_OFS_OVERRUN				= 4;
	AD02_WM_OFS_EXIN					= 5;
	//-----------------------------------------------------------------
	// \[X\̊evf̍ő吔
	//-----------------------------------------------------------------
	AD02_MAX_MEM							=	 9;
	AD02_MAX_IO								= 20;
	AD02_MAX_IRQ							=	 7;
	AD02_MAX_DMA							=	 7;

type
	//-----------------------------------------------------------------
	// \[X\
	//-----------------------------------------------------------------
	TAD02_RESOURCE = record
		dwNumMemWindows:															DWord;	{ س޳(gp) }
		dwMemBase:			array [1 .. AD02_MAX_MEM] of	DWord;	{ س޳ްڽ(gp) }
		dwMemLength:		array [1 .. AD02_MAX_MEM] of	DWord;	{ س޳(gp) }
		dwMemAttrib:		array [1 .. AD02_MAX_MEM] of	DWord;	{ س޳(gp) }
		dwNumIOPorts:																	DWord;	{ I/O߰Đ }
		dwIOPortBase:		array [1 .. AD02_MAX_IO] of		DWord;	{ I/O߰ްڽ }
		dwIOPortLength: array [1 .. AD02_MAX_IO] of		DWord;	{ I/O߰Ē }
		dwNumIRQs:																		DWord;	{ IRQ }
		dwIRQRegisters: array [1 .. AD02_MAX_IRQ] of	DWord;	{ IRQؽ }
		dwIRQAttrib:		array [1 .. AD02_MAX_IRQ] of	DWord;	{ IRQؽ }
		dwNumDMAs:																		DWord;	{ DMAِ(gp) }
		dwDMALst:				array [1 .. AD02_MAX_DMA] of	DWord;	{ DMAؽ(gp) }
		dwDMAAttrib:		array [1 .. AD02_MAX_DMA] of	DWord;	{ DMAّؽ(gp) }
		dwReserved1:		array [1 .. 3] of							DWord;	{ \(gp) }
	end;
PAD02R = ^TAD02_RESOURCE;
type
	//-----------------------------------------------------------------
	// 샂[h\
	//-----------------------------------------------------------------
	TAD02_MODE = record
		dwVoltageRange:			DWord;		// dW
		dwChFirst:					DWord;		// Jn`l
		dwChLast:						DWord;		// ŏI`l
		dwTimer:						DWord;		// ^C}
		dwTrigSource:				DWord;		// gK\[X
		dwSampleMode:				DWord;		// TvO[h
		cwBuffer:						DWord;		// obt@TCY
	end;
PCAD02M = ^TAD02_MODE;

type
	//-----------------------------------------------------------------
	// TvOf[^i[obt@
	// obt@TCYύXꍇAAD02_BUFFER_SIZE ύXĉ
	//-----------------------------------------------------------------
	TADBUFF = array[1..AD02_BUFFER_SIZE] of Word;
	PADBUFF = ^TADBUFF;

{ DLL [h }
function Ad02wDllOpen: Boolean;
{ DLL A[h }
function Ad02wDllClose: Boolean;

{ AXP-AD02 DLL,Drṽo[Wԍ擾 }
function Ad02wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
{ CӂAXP-AD02̎gp錾 }
function Ad02wCreate(var pwLogSocket: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
{ CӂAXP-AD02̎gpJ }
function Ad02wClose(wLogSocket: Word): Boolean;
{ \[X擾 }
function Ad02wGetResource(wLogSocket: Word; pres: PAD02R): Boolean;
{ TvO샂[hݒ }
function Ad02wSetMode(wLogSocket: Word; pmode: PCAD02M):Boolean;
{ TvOJn }
function Ad02wStartSampling(wLogSocket: Word):Boolean;
{ TvO~ }
function Ad02wStopSampling(wLogSocket: Word):Boolean;
{ TvOԂ̎擾 }
function Ad02wGetSamplingStatus(wLogSocket: Word; var pcwData:Dword; var pdwStatus:DWord):Boolean;
{ TvOς݃f[^̎擾 }
function Ad02wGetData(wLogSocket: Word;pwData:PADBUFF;cwData:DWord):Boolean;
{ ėp͒l̎擾 }
function Ad02wInPort(wLogSocket: Word; var pbValue:Byte ):Boolean;
{ ėpo͂ɒlo }
function Ad02wOutPort(wLogSocket: Word; bValue:Byte ):Boolean;
{ VOTvOf[^擾 }
function Ad02wSingleSampling(wLogSocket: WORD; dwCh: DWORD; dwVoltageRange: DWORD; var pwData: WORD ):Boolean;
{ G[R[h̎擾 }
function Ad02wGetLastError(wLogSocket: Word): DWord;

implementation

type

	TAd02GetVersion = function(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean; stdcall;
	TAd02Create = function(var pwLogSocket: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean; stdcall;
	TAd02Close = function(wLogSocket:	Word): Boolean; stdcall;
	TAd02GetResource = function(wLogSocket: Word; pres: PAD02R): Boolean; stdcall;
	TAd02SetMode = function(wLogSocket: Word; pmode: PCAD02M):Boolean; stdcall;
	TAd02StartSampling = function(wLogSocket: Word):Boolean; stdcall;
	TAd02StopSampling = function(wLogSocket: Word):Boolean; stdcall;
	TAd02GetSamplingStatus = function(wLogSocket: Word; var pcwData:Dword; var pdwStatus:DWord):Boolean; stdcall;
	TAd02GetData = function(wLogSocket: Word;pwData:PADBUFF;cwData:DWord):Boolean; stdcall;
	TAd02GetLastError = function(wLogSocket: Word): DWord; stdcall;
	TAd02InPort = function(wLogSocket:Word;var pbValue:Byte):Boolean; stdcall;
	TAd02OutPort = function(wLogSocket:Word;pbValue:Byte):Boolean; stdcall;
	TAd02SingleSampling = function(wLogSocket:Word;dwCh:DWord;dwVoltageRange:DWord;var pwData:WORD):Boolean; stdcall;


function Ad02wGetDllExportFunc: Boolean; forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

{ DLL GNX|[g֐AhX̊i[ϐ }
var

	pAd02GetVersion:				TAd02GetVersion;
	pAd02Create:						TAd02Create;
	pAd02Close:							TAd02Close;
	pAd02GetResource:				TAd02GetResource;
	pAd02SetMode:						TAd02SetMode;
	pAd02StartSampling:			TAd02StartSampling;
	pAd02StopSampling:			TAd02StopSampling;
	pAd02GetSamplingStatus:	TAd02GetSamplingStatus;
	pAd02GetData:						TAd02GetData;
	pAd02GetLastError:			TAd02GetLastError;
	pAd02InPort:						TAd02InPort;
	pAd02OutPort:						TAd02OutPort;
	pAd02SingleSampling:		TAd02SingleSampling;

//===================================================================
// 		Axpad02.dll[h
// 		
// ߂l  True
//				s False
//===================================================================
function Ad02wDllOpen: Boolean;
begin
	Result := False;
	if hDLL <> 0 then Exit;
	hDLL := LoadLibrary(AD02_DLL_NAME);
	if hDLL = 0 then Exit;
	if Ad02wGetDllExportFunc = False then
	begin
		Ad02wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;
	Result := True;
end;
//===================================================================
// 		Axpad02.dllA[h
// 		
// ߂l  True
//				s False
//===================================================================
function Ad02wDllClose: Boolean;
begin
	Result := True;
	if hDLL = 0 then Exit;
	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;
//===================================================================
// 		AXP-AD02 DLL,Vxd̃o[Wԍ擾
// 		pdwDllVer DLLo[Wԍi[
//				pdwDrvVer Drvo[Wԍi[
// ߂l  True
//				s False
//===================================================================
function Ad02wGetVersion(var pdwDllVer: DWord; var pdwDrvVer: DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAd02GetVersion(pdwDllVer, pdwDrvVer);
end;
//===================================================================
// 		AXP-AD02̔Cӂ̃foCX̎gp錾
// 		pwLogSocket	gpfoCXi[
//        hWnd				EChEnh
//        uWMBase			bZ[Wl
//        pvInitArg		\igpj
// ߂l  True
//				s False
//===================================================================
function Ad02wCreate(var pwLogSocket: Word; hWnd: THandle; uWMBase: UInt; var pvInitArg): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAd02Create(pwLogSocket, hWnd, uWMBase, pvInitArg);
end;
//===================================================================
// 		AXP-AD02̔Cӂ̃foCX̎gpJ
// 		wLogSocket gpfoCX
// ߂l  True
//				s False
//===================================================================
function Ad02wClose(wLogSocket: Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAd02Close(wLogSocket);
end;
//===================================================================
// 		wfoCX̃\[X擾
// 		wLogSocket	ׂfoCX
//				pres		 		\[Xi[\
// ߂l  True
//				s False
//===================================================================
function Ad02wGetResource(wLogSocket: Word; pres: PAD02R): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAd02GetResource(wLogSocket, pres);
end;
//===================================================================
// 		TvO샂[hݒ
// 		wLogSocket	ΏۃfoCX
//				pmode		 		샂[h\̂̃AhX
// ߂l  True
//				s False
//===================================================================
function Ad02wSetMode(wLogSocket: Word; pmode: PCAD02M):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAd02SetMode(wLogSocket, pmode);
end;
//===================================================================
// 		TvOJn
// 		wLogSocket	ΏۃfoCX
// ߂l  True
//				s False
//===================================================================
function Ad02wStartSampling(wLogSocket: Word):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAd02StartSampling(wLogSocket);
end;
//===================================================================
// 		TvO~
// 		wLogSocket	ΏۃfoCX
// ߂l  True
//				s False
//===================================================================
function Ad02wStopSampling(wLogSocket: Word):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAd02StopSampling(wLogSocket);
end;
//===================================================================
// 		TvOԂ̎擾
// 		wLogSocket	ΏۃfoCX
//        pcwData			TvOς݃f[^i[̈ւ̃|C^
//        pdwStatus		Xe[^Xi[̈ւ̃|C^
// ߂l  True
//				s False
//===================================================================
function Ad02wGetSamplingStatus(wLogSocket: Word; var pcwData:Dword; var pdwStatus:DWord):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAd02GetSamplingStatus(wLogSocket,pcwData,pdwStatus);
end;
//===================================================================
// 		TvOς݃f[^̎擾
// 		wLogSocket	ΏۃfoCX
//        pwData			f[^i[̈ւ̃|C^
//        cwData			ǂݏof[^
// ߂l  True
//				s False
//===================================================================
function Ad02wGetData(wLogSocket: Word;pwData:PADBUFF;cwData:DWord):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAd02GetData(wLogSocket,pwData,cwData);
end;
//===================================================================
// 		ėp͂̒l擾
// 		wLogSocket	ΏۃfoCX
//				pbValue			͒li[̈ւ̃|C^
// ߂l	 True
//				s False
//===================================================================
function Ad02wInPort(wLogSocket: Word; var pbValue:Byte ):Boolean;
begin
	Result:=False;
	if hDLL = 0 then Exit;
	Result:=pAd02InPort(wLogSocket,pbValue);
end;
//===================================================================
// 		ėpo͂ɒlo
// 		wLogSocket	ΏۃfoCX
//				bValue			o͒l
// ߂l	 True
//				s False
//===================================================================
function Ad02wOutPort(wLogSocket: Word; bValue:Byte ):Boolean;
begin
	Result:=False;
	if hDLL = 0 then Exit;
	Result:=pAd02OutPort(wLogSocket,bValue);
end;
//===================================================================
// 		VOTvOf[^擾
// 		wLogSocket			ΏۃfoCX
//				dwCh						Ώۃ`l
//        dwVoltageRange  dW
//				pwData					ϊli[̈ւ̃|C^
// ߂l	 True
//				s False
//===================================================================
function Ad02wSingleSampling(wLogSocket: WORD; dwCh: DWORD; dwVoltageRange: DWORD; var pwData: WORD ):Boolean;
begin
	Result:=False;
	if hDLL = 0 then Exit;
	Result:=pAd02SingleSampling(wLogSocket,dwCh,dwVoltageRange,pwData);
end;
//===================================================================
// 		AXP-AD02̃G[R[h
// 		wLogSocket	G[foCX
// ߂l G[R[h
//===================================================================
function Ad02wGetLastError(wLogSocket: Word): DWord;
begin
	Result := AD02_ERR_WRAPDLL;
	if hDLL = 0 then Exit;
	Result := pAd02GetLastError(wLogSocket);
end;
//-------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Ad02wGetDllExportFunc: Boolean;
begin
	Result := False;

	// Ad02GetVersion ̃AhX擾
	pAd02GetVersion := GetProcAddress(hDLL, 'Ad02GetVersion');
	if @pAd02GetVersion = nil then Exit;

	// Ad02Create ̃AhX擾
	pAd02Create := GetProcAddress(hDLL, 'Ad02Create');
	if @pAd02Create = nil then Exit;

	// Ad02Close ̃AhX擾
	pAd02Close := GetProcAddress(hDLL, 'Ad02Close');
	if @pAd02Close = nil then Exit;

	// Ad02GetResource ̃AhX擾
	pAd02GetResource := GetProcAddress(hDLL, 'Ad02GetResource');
	if @pAd02GetResource = nil then Exit;

	// Ad02SetMode ̃AhX擾
	pAd02SetMode := GetProcAddress(hDLL, 'Ad02SetMode');
	if @pAd02SetMode = nil then Exit;

	// Ad02StartSampling ̃AhX擾
	pAd02StartSampling := GetProcAddress(hDLL, 'Ad02StartSampling');
	if @pAd02StartSampling = nil then Exit;

	// Ad02StopSampling ̃AhX擾
	pAd02StopSampling := GetProcAddress(hDLL, 'Ad02StopSampling');
	if @pAd02StopSampling = nil then Exit;

	// Ad02GetSamplingStatus ̃AhX擾
	pAd02GetSamplingStatus := GetProcAddress(hDLL, 'Ad02GetSamplingStatus');
	if @pAd02GetSamplingStatus = nil then Exit;

	// Ad02GetData ̃AhX擾
	pAd02GetData := GetProcAddress(hDLL, 'Ad02GetData');
	if @pAd02GetData = nil then Exit;

	// Ad02GetLastError ̃AhX擾
	pAd02GetLastError := GetProcAddress(hDLL, 'Ad02GetLastError');
	if @pAd02GetLastError = nil then Exit;

	// Ad02InPort ̃AhX擾
	pAd02InPort := GetProcAddress(hDLL, 'Ad02InPort');
	if @pAd02InPort = nil then Exit;

	// Ad02OutPort ̃AhX擾
	pAd02OutPort := GetProcAddress(hDLL, 'Ad02OutPort');
	if @pAd02OutPort = nil then Exit;

	pAd02SingleSampling := GetProcAddress(hDLL, 'Ad02SingleSampling' );
	if @pAd02SingleSampling = nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.
