/*============================================================================
//	Axpad02w.h
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
#pragma once

#include <windows.h>

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Threading;
using namespace System::Runtime::InteropServices;

#ifdef MessageBox
#undef MessageBox
#endif

// NX̐錾
__gc public class Axpad02w;

__gc public class Axpad02w
{
private:
	static int mErrWradll = SUCCESS;	// bp[֐G[

public:
	static const short	SOCKET_AUTO				= -1;
	static const int	MAX_SOCKETS				= 4;
	static const int	NUM_CHANNELS			= 8;
	//-------------------------------------------------------------------
	// dW
	//-------------------------------------------------------------------
	static const int	VR_S10V					= 0;	// +-10V range
	static const int	VR_S5V					= 1;	// +- 5V range
	//-------------------------------------------------------------------
	// gK
	//-------------------------------------------------------------------
	static const int	TS_INTERNAL				= 0;	// gKgp
	static const int	TS_EXTERNAL				= 1;	// OgKgp
	//-------------------------------------------------------------------
	// TvO
	//-------------------------------------------------------------------
	static const int	SM_ONESHOT				= 0;	// Vbg
	static const int	SM_CONTINUOUS			= 1;	// ATvO
	//-------------------------------------------------------------------
	// TvOXe[^X̃rbg}XN
	//-------------------------------------------------------------------
	static const int	BMSST_BUSY				= (1 <<  0);	// Busy
	static const int	BMSST_EOC				= (1 <<  1);	// Not busy
	static const int	BMSST_HALF_FULL			= (1 <<  2);	// Ring buffer half full
	static const int	BMSST_OVERFLOW			= (1 <<  3);	// Ring buffer overflow
	static const int	BMSST_OVERRUN			= (1 <<  4);	// FIFO overrun
	//-------------------------------------------------------------------
	// AvP[Vɑ郁bZ[W
	// ̒l uWMBase𑫂l𑗏o܂
	//-------------------------------------------------------------------
	static const int	WM_OFS_CARD_REMOVAL		= 0;
	static const int	WM_OFS_EOC				= 1;
	static const int	WM_OFS_HALF_FULL		= 2;
	static const int	WM_OFS_OVERFLOW			= 3;
	static const int	WM_OFS_OVERRUN			= 4;
	static const int	WM_OFS_EXIN				= 5;
	//-------------------------------------------------------------------
	// 샂[h\
	//-------------------------------------------------------------------
	[StructLayout(LayoutKind::Sequential)]
	__gc class Mode
	{
	public:
		Int32	dwVoltageRange;		// dW
		Int32	dwChFirst;			// Jn`l
		Int32	dwChLast;			// ŏI`l
		Int32	dwTimer;			// ^C}
		Int32	dwTrigSource;		// gK\[X
		Int32	dwSampleMode;		// TvO[h
		Int32	cwBuffer;			// obt@TCY
	};
	//-------------------------------------------------------------------
	// \[X\
	//-------------------------------------------------------------------
	static const int	MAX_MEM					= 9;
	static const int	MAX_IO					= 20;
	static const int	MAX_IRQ					= 7;
	static const int	MAX_DMA					= 7;
	static const int	MAX_RSV					= 3;

	[StructLayout(LayoutKind::Sequential)]
	__gc class Resource
	{
	public:
		Int32 dwNumMemWindows;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad02w::MAX_MEM)]
		Int32 dwMemBase[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad02w::MAX_MEM)]
		Int32 dwMemLength[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad02w::MAX_MEM)]
		Int32 dwMemAttrib[];
		Int32 dwNumIOPorts;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad02w::MAX_IO)]
		Int32 dwIOPortBase[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad02w::MAX_IO)]
		Int32 dwIOPortLength[];
		Int32 dwNumIRQs;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad02w::MAX_IRQ)]
		Int32 dwIRQRegisters[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad02w::MAX_IRQ)]
		Int32 dwIRQAttrib[];
		Int32 dwNumDMAs;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad02w::MAX_DMA)]
		Int32 dwDMALst[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad02w::MAX_DMA)]
		Int32 dwDMAAttrib[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Axpad02w::MAX_RSV)]
		Int32 dwReserved1[];
	};
	//-------------------------------------------------------------------
	// G[R[h
	//-------------------------------------------------------------------
	static const int	SUCCESS					= 0;	// ُȂiIj
	static const int	ERR_SYSTEM				= 1;	// ɃhCo[hĂȂ\܂
	static const int	ERR_NO_DEVICE			= 2;	// gp\ȃfoCX܂
	static const int	ERR_NOT_CREATED			= 3;	// w̃foCX͎gp錾Ă܂
	static const int	ERR_IN_USE				= 4;	// w̃foCX͑̃vZXŎgpł
	static const int	ERR_INVALID_SOCKET		= 5;	// Ș_\Pbgԍł
	static const int	ERR_RESOURCE			= 6;	// \[XG[
	static const int	ERR_INVALID_ARGUMENT	= 7;	// sȈw肵܂
	static const int	ERR_VOLTAGE_RANGE		= 8;	// sȓdlw肵܂
	static const int	ERR_CHANNEL				= 9;	// sȃ`lw肵܂
	static const int	ERR_TIMER				= 10;	// sȃ^C}w肵܂
	static const int	ERR_TRIG_SOURCE			= 11;	// sȃgKw肵܂
	static const int	ERR_SAMPLE_MODE			= 12;	// sȃ[hw肵܂
	static const int	ERR_NOT_ENOUGH_MEM		= 13;	// w肳ꂽobt@mۂł܂ł
	static const int	ERR_NO_DATA				= 14;	// f[^v܂
	static const int	ERR_NO_DLL				= 15;	// ckkɃ[h܂ł
	static const int	ERR_NO_SETMODE			= 20;	// [hݒ肳Ă܂ł
	static const int	ERR_BUSY				= 21;	// TvO쒆ł
	static const int	ERR_WRAPDLL				= -1;	// bp[֐G[
	//-------------------------------------------------------------------
	// API
	//-------------------------------------------------------------------
	[DllImport("axpad02.dll")]
	static bool Ad02GetVersion ( int* pdwDllVer, int* pdwDrvVer );
	[DllImport("axpad02.dll")]
	static bool Ad02Create( short* pwLogSocket, int hWnd, short uWMBase, int* pvInitArg );
	[DllImport("axpad02.dll")]
	static bool Ad02Close ( short wLogSocket );
	[DllImport("axpad02.dll")]
	static bool Ad02GetResource ( short wLogSocket, [In][Out] Resource* pResInfo );
	[DllImport("axpad02.dll")]
	static bool Ad02SetMode ( short wLogSocket, [In][Out] Mode* pmode );
	[DllImport("axpad02.dll")]
	static bool Ad02StartSampling ( short wLogSocket );
	[DllImport("axpad02.dll")]
	static bool Ad02StopSampling ( short wLogSocket );
	[DllImport("axpad02.dll")]
	static bool Ad02GetSamplingStatus ( short wLogSocket, int* pcwData, int* pdwStatus );
	[DllImport("axpad02.dll")]
	static bool Ad02GetData ( short wLogSocket, short* pwData, int cwData );
	[DllImport("axpad02.dll")]
	static bool Ad02OutPort ( short wLogSocket, Byte bValue );
	[DllImport("axpad02.dll")]
	static bool Ad02InPort ( short wLogSocket, Byte* pbValue );
	[DllImport("axpad02.dll")]
	static bool Ad02SingleSampling( short wLogSocket, int dwCh, int dwVoltageRange, short* pwData );
	[DllImport("axpad02.dll")]
	static int  Ad02GetLastError ( short wLogSocket ); 

	/*****************************************************************************
	 * @\  AXP-AD02DLL,Driver̃o[Wԍ擾
	 * 	 pdwDllVer --- DLLo[Wԍi[AhX
	 *		 pdwDrvVer --- Drivero[Wԍi[AhX
	 * ߒl	 true	   --- 
	 *		 false	   --- s
	 *****************************************************************************/
	static bool GetVersion ( int* pdwDllVer, int* pdwDrvVer )
	{
		try {
			return Ad02GetVersion(pdwDllVer, pdwDrvVer);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  AXP-AD02̔Cӂ̃foCX̎gp錾
	 * 	 pwLogSocket	--- gpfoCXi[AhX
	 *       hWnd       --- bZ[W󂯂EChEnh
	 *       uWMBase    --- bZ[Whc̃x[X
	 *       pvInitArg  --- \
	 * ߒl	 true		--- 
	 *		 false		--- s
	 *****************************************************************************/
	static bool Create ( short* pwLogSocket, int hWnd, short uWMBase, int* pvInitArg )
	{
		try {
			return Ad02Create(pwLogSocket, hWnd, uWMBase, pvInitArg);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  AXP-AD02̔Cӂ̃foCX̎gpJ
	 * 	 wLogSocket  --- gpfoCX
	 * ߒl	 true	   --- 
	 *		 false	   --- s
	 *****************************************************************************/
	static bool Close ( short wLogSocket )
	{
		try {
			return Ad02Close(wLogSocket);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  wfoCX̃\[X擾
	 * 	 wLogSocket --- ׂfoCX
	 *		 pResInfo --- \[Xi[\̂̃AhX
	 * ߒl	 true	  --- 
	 *		 false	  --- s
	 *****************************************************************************/
	static bool GetResource ( short wLogSocket, [In][Out] Resource* pResInfo )
	{
		try {
			return Ad02GetResource(wLogSocket, pResInfo);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  TvO샂[hݒ
	 * 	 wLogSocket --- foCX
	 *		 pmode      --- [hݒf[^
	 * ߒl	 true	    --- 
	 *		 false	    --- s
	 *****************************************************************************/
	static bool SetMode ( short wLogSocket, [In][Out] Mode* pmode )
	{
		try {
			return Ad02SetMode(wLogSocket, pmode);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  TvOJn
	 * 	 wLogSocket --- foCX
	 * ߒl	 true	    --- 
	 *		 false	    --- s
	 *****************************************************************************/
	static bool StartSampling ( short wLogSocket )
	{
		try {
			return Ad02StartSampling(wLogSocket);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  TvO~
	 * 	 wLogSocket --- foCX
	 * ߒl	 true	    --- 
	 *		 false	    --- s
	 *****************************************************************************/
	static bool StopSampling ( short wLogSocket )
	{
		try {
			return Ad02StopSampling(wLogSocket);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  TvOԂ̎擾
	 * 	 wLogSocket --- foCX
	 *       pcwData    --- TvOς݃f[^i[̈ւ̃|C^
	 *       pdwStatus  --- TvOXe[^Xi[̈ւ̃|C^
	 * ߒl	 true	    --- 
	 *		 false	    --- s
	 *****************************************************************************/
	static bool GetSamplingStatus ( short wLogSocket, int* pcwData, int* pdwStatus )
	{
		try {
			return Ad02GetSamplingStatus(wLogSocket,pcwData,pdwStatus);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  TvOς݃f[^̎擾
	 * 	 wLogSocket --- foCX
	 *       pwData     --- TvOς݃f[^i[̈ւ̃|C^
	 *       cwData     --- ǂݏof[^
	 * ߒl	 true	    --- 
	 *		 false	    --- s
	 *****************************************************************************/
	static bool GetData ( short wLogSocket, short* pwData, int cwData )
	{
		try {
			return Ad02GetData(wLogSocket,pwData,cwData);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  ėpo̓|[gɒlo
	 * 	 wLogSocket --- foCX
	 *       bValue     --- o͂l
	 * ߒl	 true	    --- 
	 *		 false	    --- s
	 *****************************************************************************/
	static bool OutPort ( short wLogSocket, Byte bValue )
	{
		try {
			return Ad02OutPort(wLogSocket,bValue);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  ėp̓|[g̒l擾
	 * 	 wLogSocket --- foCX
	 *       pbValue    --- 擾li[̈̃|C^
	 * ߒl	 true	    --- 
	 *		 false	    --- s
	 *****************************************************************************/
	static bool InPort ( short wLogSocket, Byte* pbValue )
	{
		try {
			return Ad02InPort(wLogSocket,pbValue);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  ėp̓|[g̒l擾
	 * 	 wLogSocket --- foCX
	 *       pbValue    --- 擾li[̈̃|C^
	 * ߒl	 true	    --- 
	 *		 false	    --- s
	 *****************************************************************************/
	static bool SingleSampling( short wLogSocket, int dwCh, int dwVoltageRange, short* pwData )
	{
		try {
			return Ad02SingleSampling(wLogSocket,dwCh,dwVoltageRange,pwData);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*****************************************************************************
	 * @\  G[R[h擾
	 * 	 wLogSocket --- ΏۃfoCX
	 * ߒl	 G[R[h
	 *****************************************************************************/
	static int GetLastError( short wLogSocket )
	{
		try {
			if (mErrWradll == ERR_WRAPDLL) {	// bp[֐G[Ȃ
				mErrWradll = SUCCESS;			// NA
				return ERR_WRAPDLL;
			} else {
				return Ad02GetLastError(wLogSocket);
			}
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"AXP-AD02 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = SUCCESS;	// bp[֐G[
			return ERR_WRAPDLL;
		}
		
	}

};
