/*****************************************************************************
 * Axpad02w.c
 *
 * AXP-AD02
 * Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
/*****************************************************************************/
#include <windows.h>
#include <tchar.h>
#include "axpad02w.h"
//---------- X^eBbN֐ & X^eBbNϐ(萔)	----------------------
static BOOL Ad02wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static FARPROC pAd02GetVersion;
static FARPROC pAd02Create;
static FARPROC pAd02Close;
static FARPROC pAd02GetResource;
static FARPROC pAd02SetMode;
static FARPROC pAd02StartSampling;
static FARPROC pAd02StopSampling;
static FARPROC pAd02GetSamplingStatus;
static FARPROC pAd02GetData;
static FARPROC pAd02GetLastError;
static FARPROC pAd02OutPort;
static FARPROC pAd02InPort;
static FARPROC pAd02SingleSampling;

BOOL Ad02wDllOpen ( void )
/*****************************************************************************
 * @\  axpad02.dll[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL != NULL) {
		return FALSE;
	}
	hDLL = (HMODULE)LoadLibrary(AD02_DLL_NAME);
	if (hDLL == NULL) {
		return FALSE;
	}
	if (Ad02wGetDllExportFunc() == FALSE) {
		// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Ad02wDllClose();
		return FALSE;
	}
	return TRUE;
}

BOOL Ad02wDllClose ( void )
/*****************************************************************************
 * @\  axpad02.dllA[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	if (FreeLibrary(hDLL) == TRUE) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

BOOL Ad02wGetVersion ( PDWORD pdwDllVer, PDWORD pdwDrvVer )
/*****************************************************************************
 * @\  AXP-AD02DLL,Driver̃o[Wԍ擾
 * 	 pdwDllVer --- DLLo[Wԍi[AhX
 *		 pdwDrvVer --- Drivero[Wԍi[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAd02GetVersion)(pdwDllVer, pdwDrvVer);
}

BOOL Ad02wCreate ( PWORD pwLogSocket, HWND hWnd, UINT uWMBase, PVOID pvInitArg )
/*****************************************************************************
 * @\  AXP-AD02̔Cӂ̃foCX̎gp錾
 * 	 pwLogSocket	--- gpfoCXi[AhX
 *       hWnd       --- bZ[W󂯂EChEnh
 *       uWMBase    --- bZ[Whc̃x[X
 *       pvInitArg  --- \
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAd02Create)(pwLogSocket, hWnd, uWMBase, pvInitArg);
}            

BOOL Ad02wClose ( WORD wLogSocket )
/*****************************************************************************
 * @\  AXP-AD02̔Cӂ̃foCX̎gpJ
 * 	 wLogSocket  --- gpfoCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAd02Close)(wLogSocket);
}

BOOL Ad02wGetResource ( WORD wLogSocket, PAD02R pResInfo )
/*****************************************************************************
 * @\  wfoCX̃\[X擾
 * 	 wLogSocket --- ׂfoCX
 *		 pResInfo --- \[Xi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAd02GetResource)(wLogSocket, pResInfo);
}

BOOL Ad02wSetMode (WORD wLogSocket, PCAD02M pmode)
/*****************************************************************************
 * @\  TvO샂[hݒ
 * 	 wLogSocket --- foCX
 *		 pmode      --- [hݒf[^
 * ߒl	 TRUE	    --- 
 *		 FALSE	    --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAd02SetMode)(wLogSocket, pmode);
}

BOOL Ad02wStartSampling (WORD wLogSocket)
/*****************************************************************************
 * @\  TvOJn
 * 	 wLogSocket --- foCX
 * ߒl	 TRUE	    --- 
 *		 FALSE	    --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAd02StartSampling)(wLogSocket);
}

BOOL Ad02wStopSampling (WORD wLogSocket)
/*****************************************************************************
 * @\  TvO~
 * 	 wLogSocket --- foCX
 * ߒl	 TRUE	    --- 
 *		 FALSE	    --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAd02StopSampling)(wLogSocket);
}

BOOL Ad02wGetSamplingStatus (WORD wLogSocket, PDWORD pcwData, PDWORD pdwStatus)
/*****************************************************************************
 * @\  TvOԂ̎擾
 * 	 wLogSocket --- foCX
 *       pcwData    --- TvOς݃f[^i[̈ւ̃|C^
 *       pdwStatus  --- TvOXe[^Xi[̈ւ̃|C^
 * ߒl	 TRUE	    --- 
 *		 FALSE	    --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAd02GetSamplingStatus)(wLogSocket,pcwData,pdwStatus);
}

BOOL Ad02wGetData (WORD wLogSocket, PWORD pwData, DWORD cwData)
/*****************************************************************************
 * @\  TvOς݃f[^̎擾
 * 	 wLogSocket --- foCX
 *       pwData     --- TvOς݃f[^i[̈ւ̃|C^
 *       cwData     --- ǂݏof[^
 * ߒl	 TRUE	    --- 
 *		 FALSE	    --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAd02GetData)(wLogSocket,pwData,cwData);
}

BOOL Ad02wOutPort (WORD wLogSocket, BYTE bValue )
/*****************************************************************************
 * @\  ėpo̓|[gɒlo
 * 	 wLogSocket --- foCX
 *       bValue     --- o͂l
 * ߒl	 TRUE	    --- 
 *		 FALSE	    --- s
 *****************************************************************************/
{
	if(hDLL == NULL) {
		return FALSE;
	}
	return (*pAd02OutPort)(wLogSocket,bValue);
}

BOOL Ad02wInPort (WORD wLogSocket, PBYTE pbValue )
/*****************************************************************************
 * @\  ėp̓|[g̒l擾
 * 	 wLogSocket --- foCX
 *       pbValue    --- 擾li[̈̃|C^
 * ߒl	 TRUE	    --- 
 *		 FALSE	    --- s
 *****************************************************************************/
{
	if(hDLL == NULL) {
		return FALSE;
	}
	return (*pAd02InPort)(wLogSocket,pbValue);
}

BOOL Ad02wSingleSampling(WORD wLogSocket,DWORD dwCh, DWORD dwVoltageRange, PWORD pwData )
/*****************************************************************************
 * @\  ėp̓|[g̒l擾
 * 	 wLogSocket --- foCX
 *       pbValue    --- 擾li[̈̃|C^
 * ߒl	 TRUE	    --- 
 *		 FALSE	    --- s
 *****************************************************************************/
{
	if(hDLL == NULL) {
		return FALSE;
	}
	return (*pAd02SingleSampling)(wLogSocket,dwCh,dwVoltageRange,pwData);
}


DWORD Ad02wGetLastError( WORD wLogSocket )
/*****************************************************************************
 * @\  G[R[h擾
 * 	 wLogSocket --- ΏۃfoCX
 * ߒl	 G[R[h
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return AD02_ERR_WRAPDLL;
	}
	return (*pAd02GetLastError)(wLogSocket);
}

static BOOL Ad02wGetDllExportFunc ( void )
/*---------------------------------------------------------------------------
 * 	 DLLGNX|[g֐AhX̎擾
 * 	 Ȃ
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *---------------------------------------------------------------------------*/
{
	// Ad02GetVersion ̃AhX擾
	pAd02GetVersion = GetProcAddress(hDLL, "Ad02GetVersion");
	if (pAd02GetVersion == NULL) return FALSE;

	// Ad02Create ̃AhX擾
	pAd02Create = GetProcAddress(hDLL, "Ad02Create");
	if (pAd02Create == NULL) return FALSE;

	// Ad02Close ̃AhX擾
	pAd02Close = GetProcAddress(hDLL, "Ad02Close");
	if (pAd02Close == NULL) return FALSE;

	// Ad02GetResource ̃AhX擾
	pAd02GetResource = GetProcAddress(hDLL, "Ad02GetResource");
	if ( pAd02GetResource == NULL ) return FALSE;

	// Ad02SetMode ̃AhX擾
	pAd02SetMode = GetProcAddress(hDLL, "Ad02SetMode");
	if ( pAd02SetMode == NULL ) return FALSE;

	// Ad02StartSampling ̃AhX擾
	pAd02StartSampling = GetProcAddress(hDLL, "Ad02StartSampling");
	if ( pAd02StartSampling == NULL ) return FALSE;

	// Ad02StopSampling ̃AhX擾
	pAd02StopSampling = GetProcAddress(hDLL, "Ad02StopSampling");
	if ( pAd02StopSampling == NULL ) return FALSE;

	// Ad02GetSamplingStatus ̃AhX擾
	pAd02GetSamplingStatus = GetProcAddress(hDLL, "Ad02GetSamplingStatus");
	if ( pAd02GetSamplingStatus == NULL ) return FALSE;

	// Ad02GetData ̃AhX擾
	pAd02GetData = GetProcAddress(hDLL, "Ad02GetData");
	if ( pAd02GetData == NULL ) return FALSE;

	// Ad02OutPort ̃AhX擾
	pAd02OutPort = GetProcAddress(hDLL, "Ad02OutPort");
	if ( pAd02OutPort == NULL ) return FALSE;

	// Ad02InPort ̃AhX擾
	pAd02InPort = GetProcAddress(hDLL, "Ad02InPort");
	if ( pAd02InPort == NULL ) return FALSE;

	// Ad02SingleSampling ̃AhX擾
	pAd02SingleSampling = GetProcAddress(hDLL, "Ad02SingleSampling");
	if ( pAd02SingleSampling == NULL ) return FALSE;

	// Ad02GetLastError ̃AhX擾
	pAd02GetLastError = GetProcAddress(hDLL, "Ad02GetLastError");
	if ( pAd02GetLastError == NULL ) {
		return FALSE;
	}

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
